import { injectable } from 'ditox';
import { createScope } from './scope';
export function createController(factory) {
    const scope = createScope();
    const controller = factory(scope);
    return {
        ...controller,
        destroy: () => {
            var _a;
            (_a = controller.destroy) === null || _a === void 0 ? void 0 : _a.call(controller);
            scope.destroy();
        },
    };
}
export function declareController(tokens, factory) {
    return injectable((deps) => createController((scope) => factory(deps, scope)), tokens);
}
export function declareViewController(tokensOrFactory, factory) {
    const factoryValue = (factory !== null && factory !== void 0 ? factory : tokensOrFactory);
    const tokensValue = (factory ? tokensOrFactory : {});
    return (container, ...params) => {
        return injectable((dependencies) => {
            return createController((scope) => {
                const result = factoryValue(dependencies, scope);
                if (typeof result === 'function') {
                    return result(scope, ...params);
                }
                else {
                    return result;
                }
            });
        }, tokensValue)(container);
    };
}
//# sourceMappingURL=mvc.js.map